

#include "CC3100/include/simplelink.h"


UINT8 POST_token[] = "__SL_P_ULD";
UINT8 GET_token[]  = "__SL_G_ULD";


void method_get(SlHttpServerEvent_t *pEvent, SlHttpServerResponse_t *pResponse)
{
    UINT8 status = 0;
    UINT8 *ptr = 0;

    ptr = pResponse->ResponseData.token_value.data;
    pResponse->ResponseData.token_value.len = 0;
    if(memcmp(pEvent->EventData.httpTokenName.data, GET_token,
                                         strlen(GET_token)) == 0)
    {
        status = GetLEDStatus();    //status = ob00000xxx

        memcpy(ptr, "LED1_", strlen("LED1_"));
        ptr += 5;
        pResponse->ResponseData.token_value.len += 5;
        if(status & 0x01)
        {
            memcpy(ptr, "ON", strlen("ON"));
            ptr += 2;
            pResponse->ResponseData.token_value.len += 2;
        }
        else
        {
            memcpy(ptr, "OFF", strlen("OFF"));
            ptr += 3;
            pResponse->ResponseData.token_value.len += 3;
        }

        memcpy(ptr,",LED2_", strlen(",LED2_"));
        ptr += 6;
        pResponse->ResponseData.token_value.len += 6;
        if(status & 0x02)
        {
            memcpy(ptr, "ON", strlen("ON"));
            ptr += 2;
            pResponse->ResponseData.token_value.len += 2;
        }
        else
        {
            memcpy(ptr, "OFF", strlen("OFF"));
            ptr += 3;
            pResponse->ResponseData.token_value.len += 3;
        }
/*
        memcpy(ptr,",LED3_", strlen(",LED3_"));
        ptr += 6;
        pResponse->ResponseData.token_value.len += 6;
        if(status & 0x04)
        {
            memcpy(ptr, "ON", strlen("ON"));
            ptr += 2;
            pResponse->ResponseData.token_value.len += 2;
        }
        else
        {
            memcpy(ptr, "OFF", strlen("OFF"));
            ptr += 3;
            pResponse->ResponseData.token_value.len += 3;
        }
*/
        *ptr = '\0';        //End string with null

        ptr = pResponse->ResponseData.token_value.data;
        CLI_Write(ptr);
    }
}

void method_post(SlHttpServerEvent_t *pEvent, SlHttpServerResponse_t *pResponse)
{
    UINT8 led = 0;
    UINT8 *ptr = pEvent->EventData.httpPostData.token_name.data;

    if(memcmp(ptr, POST_token,strlen(POST_token)) == 0)
    {
        ptr = pEvent->EventData.httpPostData.token_value.data;
        CLI_Write(ptr);
        if(memcmp(ptr, "LED", 3) == 0)
        {
            ptr += 3;
            led = *ptr;
            ptr += 2;

            if(led == '1')
            {
                if(memcmp(ptr, "ON", 2) == 0)
                {
                    LED1_ON();
                }
                else
                {
                    LED1_OFF();
                }
            }
            else if(led == '2')
            {
                if(memcmp(ptr, "ON", 2) == 0)
                {
                    LED2_ON();
                }
                else
                {
                    LED2_OFF();
                }
            }
   /*        else if(led == '3')
            {
                if(memcmp(ptr, "ON", 2) == 0)
                {
                    LED3_ON();
                }
                else
                {
                    LED3_OFF();
                }
            }*/
        }
    }
}
