/*******************************************************************************
 * FileName:        Max32USB.h
 * Dependencies:    plib.h
 * Processor:       PIC32
 * Compiler:        CX32
 * Company:         Pacific Coast Motion
 * Author:          Thomas McGee
 * Created:         June 23, 2012, 1:30 PM
*******************************************************************************/

#ifndef MAX32USB_H
#define	MAX32USB_H

#include <plib.h>            // Include to use PIC32 peripheral libraries

/*******************************************************************************
 * Section: Function Prototypes
*******************************************************************************/
void OpenMaxUSB(UINT32 sourceClock, UINT32 dataRate);
void PutUSBarray(const char *buffer, int size);
void PutUSBstring(const char *buffer);
UINT32 GetUSBarray(char *buffer, int max_size);
void PutUSBbyte(UINT8 Data);
UINT8 GetUSBbyte(void);
void menuUSBchoice(void);

#endif




